#####################################
#         hTP_SimpleDM Bank         #
#####################################

import es
from configobj import ConfigObj
from htp_dm.htp_dm import connection

info = es.AddonInfo()
info.name        = "hTP_SimpleDM ba_bank option"
info.version     = "beta1"
info.author      = "HitThePipe"
info.url         = "http://forums.mattie.info/cs/forums/"
info.description = "ba_bank option for hTP_SimpleDM"

dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')

try:
    ba_config = ConfigObj(es.getAddonPath('ba_bank') + '/config/config.ini')
except:
    es.dbgmsg(1, '***** BA_BANK does not exist *****')
    es.dbgmsg(1, '***** Unloading htp_dm bank option')
    es.unload('htp_dm/bank')

es.dbgmsg(1, '****start ba_bank setup')

dbba = connection(es.getAddonPath('ba_bank') + '/data/ba_bank.db')
maxbalance = int(ba_config['settings']['bank_max_balance'])
minbalance = int(ba_config['settings']['bank_start_balance'])
ignoremax = int(dm_config['settings']['bank_settings']['ignore_max_balance'])
headshotbonus = int(dm_config['settings']['bank_settings']['headshot_cash_award'])
noawpbonus = int(dm_config['settings']['bank_settings']['allow_awp_headshot_award'])
knifebonus = int(dm_config['settings']['bank_settings']['knife_cash_award'])
knifepenalty = int(dm_config['settings']['bank_settings']['knife_death_penalty'])

if int(dm_config['settings']['bank_settings']['kill_cash_award']):
    killcash = int(dm_config['settings']['bank_settings']['kill_cash_award'])
else:
    killcash = int(ba_config['settings']['bank_min_deposit'])
es.dbgmsg(1, '***** ba_bank setup successful')

es.loadevents('declare','addons/eventscripts/htp_dm/htp_dm.res')
es.loadevents('addons/eventscripts/htp_dm/htp_dm.res')

def es_map_start(event_var):
    es.loadevents('addons/eventscripts/htp_dm/htp_dm.res')
			
def htp_deposit(event_var): 
    es.dbgmsg(1,'*****event htp_deposit received')   
    steamid = event_var['steamid']
    weapon = event_var['weapon']
    headshot = event_var['headshot']
    allowdeposit = 0
    balance = int(dbba.query("SELECT balance FROM accounts WHERE steamid='%s'" %steamid)[0][0])
    if balance:
        bonus = killcash
        balance = balance + killcash
        if int(headshot):
            if weapon != 'awp':
                balance = balance + headshotbonus
                bonus = bonus + headshotbonus
            else:
                if noawpbonus:
                    balance = balance + headshotbonus
                    bonus = bonus + headshotbonus
        if weapon == 'knife':
            balance = balance + knifebonus
        if balance >= maxbalance:
            if ignoremax:
                allowdeposit = 1
        else:
            allowdeposit = 1
        if allowdeposit: 
            dbba.execute("UPDATE accounts SET balance='%d' WHERE steamid='%s'" %(balance,steamid))
            token = {'bonus':str(bonus)}
            es.tell(event_var['userid'], prefix + dm_lang('bank_reward',token)) 

def htp_withdraw(event_var):
    es.dbgmsg(1,'*****event htp_withdraw received') 
    if event_var['weapon'] == 'knife':
        steamid = event_var['steamid']
        balance = int(dbba.query("SELECT balance FROM accounts WHERE steamid='%s'" %steamid)[0][0])
        if balance:
            balance = balance - knifepenalty
            if balance >= minbalance:
                dbba.execute("UPDATE accounts SET balance='%d' WHERE steamid='%s'" %(balance,steamid))
                token = {'bonus':str(knifepenalty)}
                es.tell(event_var['userid'], prefix + dm_lang('bank_penalty',token))     

def unload():
    dbba.close