#####################################
#       hTP_SimpleDM Ranking        #
#####################################

import es
import popuplib
import services
import langlib
from htp_dm.htp_dm import connection
from configobj import ConfigObj

es.dbgmsg(1, 'ranking loading')

info = es.AddonInfo()
info.name        = "hTP_SimpleDM Ranking"
info.version     = "beta1"
info.author      = "HitThePipe"
info.url         = "http://forums.mattie.info/cs/forums/"
info.description = "Ranking for hTP_SimpleDM"

dbr = connection(es.getAddonPath('htp_dm') + '/usersettings.db')
dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')
dm_lang = langlib.Strings(es.getAddonPath('htp_dm') + '/dm_lang.ini')
mkills = int(dm_config['settings']['rank_settings']['rank_min_kills']) - 1
ranks_limit = int(dm_config['settings']['rank_settings']['ranks_limit']) + 1
auth = services.use('auth')
ranks = {}
prefix = ('#green' + dm_config['settings']['message_prefix'] + '#default')

def load():
    auth.registerCapability("resetranks", auth.ADMIN)
    if not es.exists('saycommand', 'rank'):
        es.regsaycmd('rank', 'htp_dm/ranking/rank', 'Show player rank')
    if not es.exists('saycommand', 'top'):
        es.regsaycmd('top', 'htp_dm/ranking/top_ranks', 'Show Top# menu')        
    if not es.exists('saycommand', 'resetranks'):
        es.regsaycmd('resetranks', 'htp_dm/ranking/reset_ranks', 'Reset ranks- Admin cmd')
    if not es.exists('saycommand', 'ranks'):
        es.regsaycmd('ranks', 'htp_dm/ranking/ranks', 'Show rank range')
    if not es.exists('command', 'c_ranks'):
        es.regcmd('c_ranks', 'htp_dm/ranking/ranks', 'Server cmd')
    set_ranks()
	
def set_ranks():
    global ranks
    ranks = {}
    if not int(dm_config['settings']['rank_settings']['rank_by']):
        ranks_temp = dbr.query("SELECT SteamID,Kills,Deaths,Name,KD FROM UserSettings WHERE Kills>%d ORDER BY Kills DESC LIMIT %d;" %(mkills,ranks_limit))
        i = 1
    else:
        ranks_temp = dbr.query("SELECT SteamID,Kills,Deaths,Name,KD FROM UserSettings WHERE Kills>%d ORDER BY KD DESC LIMIT %d;" %(mkills,ranks_limit))
        i = 1
    for player in ranks_temp:
        ranks[i] = (player)
        i += 1
	
def reset_ranks():
    userid = es.getcmduserid()
    if auth.isUseridAuthorized(userid, 'resetranks'):
        dbr.execute("UPDATE UserSettings SET Kills='0',Deaths='0'")
        set_ranks()
        es.msg('#multi', prefix + dm_lang('reset ranks'))
    else:
        es.tell(userid, '#multi', prefix + dm_lang('auth refuse'))

def rank():
    global ranks
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    for rank in ranks:
        if ranks[rank][0] == steamid:      
            llimit = rank - 4
            if llimit < 1:
                llimit = 1
            ulimit = rank + 5
            if ulimit > int(dm_config['settings']['rank_settings']['ranks_limit']):
                ulimit = int(dm_config['settings']['rank_settings']['ranks_limit'])
            token = {'rank':str(rank)}
            title = dm_lang('you are ranked',token)
            ranks_menu(llimit,ulimit,userid,steamid,title)			            
            break
    else:
        token = {'ulimit':str(ulimit)}
        es.tell(userid, '#multi', prefix + dm_lang('not in top ranks',token))    

def ranks():
    es.dbgmsg(0,'*****set ranks')
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if int(es.getargc()) == 3:
        arg1 = int(es.getargv(1))
        arg2 = int(es.getargv(2))
        if (arg2 - arg1) < 16:
            if es.getargv(0) == 'ranks':
                token = {'arg1':str(arg1),'arg2':str(arg2)}
                title = dm_lang('ranked players',token)
                arg2 = arg2 + 1
                ranks_menu(arg1,arg2,userid,steamid,title)
            else:
                #spam ranks to server console
                es.dbgmsg(1, '***** [hTP_SimpleDM]Ranked Players %d - %d' %(arg1,arg2))
        else:
            if es.getargv(0) == 'ranks':
                es.tell(userid, '#multi', '%s #green[Syntax Error] use:#default ranks # # - range up to 15' %prefix)  
                es.tell(userid, '#multi', '%s #greenEx.:#default ranks 15 30' %prefix)
            else:
                es.dbgmsg(0, '***** [Syntax Error] use: c_ranks # # - range up to 15')
                es.dbgmsg(0, '***** Example: c_ranks 15 30')
    else:
        if es.getargv(0) == 'ranks':
            es.tell(userid, '#multi', '%s #green[Syntax Error] use:#default ranks # # - range up to 15' %prefix)
            es.tell(userid, '#multi', '%s #greenEx.:#default ranks 15 30' %prefix)
        else:
            es.dbgmsg(0, '***** [Syntax Error] use: c_ranks # # - range up to 15')
            es.dbgmsg(0, '***** Example: ranks 15 30')

def top_ranks():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    amount = es.getargv(1)
    amount = int(amount) + 1
    token = {'amount':str(amount)}
    if amount > 15:
        amount = 15
        token = {'amount':str(amount)}
        es.tell(userid, '#multi', prefix + dm_lang('max ranks shown',token))  
    title = dm_lang('top players',token)
    ranks_menu(1,amount,userid,steamid,title)

def ranks_menu(llimit,ulimit,userid,steamid,title):
    #global ranks
    if popuplib.exists('ranksmenu'):
        popuplib.delete('ranksmenu')
    RanksMenu = popuplib.create('ranksmenu')
    RanksMenu.addline(title)
    RanksMenu.addline('--------------')
    RanksMenu.addline(dm_lang('ranks menu'))
    RanksMenu.addline(' ') 
    for i in range(int(llimit), int(ulimit)):
        try:
            if ranks[i]:
                kd = float(ranks[i][4])
                name = dbr.utfcode(ranks[i][3])
                if ranks[i][0] == steamid:
                    RanksMenu.addline('->%d - %s: %s %s - %.2f' %(i,name,ranks[i][1],ranks[i][2],kd))
                else:
                    RanksMenu.addline('%d - %s: %s %s - %.2f' %(i,name,ranks[i][1],ranks[i][2],kd))    
        except:
            i -= 1
            RanksMenu.modline(1, 'Ranks %d - %d' %(llimit,ulimit))
            break
    RanksMenu.addline('-----------------')
    RanksMenu.addline('0. Close')
    RanksMenu.send(userid)
    popuplib.delete('ranksmenu')

def round_end(event_var):
    if int(dm_config['settings']['rank_settings']['update_ranks_interval']):
        set_ranks()

def es_map_start(event_var):
    set_ranks()

def unload():
    es.unregsaycmd('rank')
    es.unregsaycmd('top')
    es.unregsaycmd('resetranks')
    es.unregsaycmd('ranks')
    dbr.close